
'--  Script for use with jsCAB.dll. This script gets a list of files from a CAB file.
'--  Then it provides the option to extract one file. Just drop a CAB file onto the script.

Dim Arg, FSO, JSC, CPath, FPath, CInfo, sList, i2, A1, sFil

 CPath = WScript.Arguments(0)

If (Len(CPath) = 0) Then
  MsgBox "Drop a CAB file onto script to extract one file.", 64, "Extract One File"
  WScript.Quit
End If

Set FSO = CreateObject("Scripting.FileSystemObject")
  If (FSO.FileExists(CPath) = False) Then
      MsgBox "Drop a CAB file onto script to extract one file.", 64, "Extract One File"
      DropIt
  End If
  
  If UCase(Right(CPath, 4)) <> ".CAB" Then
       MsgBox "Drop a CAB file onto script to extract one file.", 64, "Extract One File"
       DropIt
  End If
 

Set JSC = CreateObject("jsCAB.Ops")
  Set CInfo = JSC.GetCABInfo(CPath)
    If (CInfo.IsValidCAB <> 0) or (CInfo.Solitary = False) Then
       If (CInfo.IsValidCAB = 1) Then
          MsgBox "This is an InstallShield CAB file. No further information available.", 64, "Extract One File"
       ElseIf (CInfo.IsValidCAB = 2) Then
           MsgBox "This is not a CAB file. No further information available.", 64, "Extract One File"
       Else
           MsgBox "This CAB file is part of a series. No further information available.", 64, "Extract One File"
       End If
         DropIt
    End If
    
     If (CInfo.FileCount = 0) Then
        MsgBox "No files found in this CAB file.", 64, "Extract One File"
        DropIt
     End If
     
      A1 = CInfo.FileList
    For i2 = 0 to CInfo.FileCount - 1
      sList = sList & A1(i2) & vbCrLf
    Next
    
     Set CInfo = Nothing
   sList = "List of files in CAB. Remember one name for extraction." & vbCrLf & vbCrLf & sList
   MsgBox sList, 64, "Extract One File"
   
'-- get file name for extraction and confirm it's in the CAB:

   sFil = InputBox("Enter file name for extraction.", "Extract One File")
      If InStr(1, sList, sFil, 1) = 0 Then
         MsgBox "Invalid file name.", 64, "Extract One File"
         DropIt
      End If

'-- Get folder path for extraction:
      
  FPath = ChooseFolder()
    If FSO.FolderExists(FPath) = False Then DropIt  '-- probably cancelled.
      
'--- ready to extract file.

Ret = JSC.ExtractSingleFile(CPath, FPath, sFil)

MsgBox "ExtractSingleFile returned: " & CStr(ret), 64, "Extract One File"
 
DropIt

'------------------------------------------------
Function ChooseFolder()
  Dim SHL, s1, FolOb, CPt, FolIOb
    Set SHL = CreateObject("Shell.Application")
    Set FolOb = SHL.BrowseForFolder(CLng(0), "Select unpacking folder.", CLng(0))

 On Error Resume Next
    If FolOb Is Nothing Then 
        s1 = ""
    Else       
       CPt = InStr(FolOb.Title, ":") 
        If CPt > 0 Then
           s1 = Fol.Title
           s1 = Mid(s1, (CPt - 1), 2) & "\"
        Else   
           Set FolIOb = FolOb.ParentFolder.ParseName(FolOb.Title)
           s1 = FolIOb.Path
        End If  
          Set FolIOb = Nothing
          Set FolOb = Nothing
    End If     
         
         Set SHL = Nothing
     ChooseFolder = s1  
End Function

Sub DropIt()
   On Error Resume Next
 Set FSO = Nothing
 Set CInfo = Nothing
 Set JSC = Nothing
   WScript.Quit
End Sub